%***************************
% Written by Farinaz Edalat
% May 9, 2005
%***************************

%****************************************************************
%Description: This file plots for all N subchannels
% (1) Scatterplot (or Constellation) of transmitted symbols (at the input of IFFT) and received
% symbols before equalization (at the output of FFT)

% (2) Scatterplot (or Constellation) of transmitted symbols (at the input of IFFT) and received
% symbols after equalization (at the output of one-tap Equalizer)

% To avoid confusion between the figures, it is suggested to plot (1) or
% (2) at a time and not both at the same time. Hence, you can comment-out
% one or the other. For instance, we have commented out (1) now.
%*****************************************************************

% Given Parameters:*******************
x = loadsig_cppsim('test_rx.tr0');  
N = 8;  % number of subchannels (=num_channels)
p = 1;  % number of pilot symbols
%*************************************

% (1)
% k = 0;
% for (n=1:N)
%     % Transmitted symbols
%     vec_pilot_i = sprintf('xi11_vec_pilot_i_%d',k);
%     vec_pilot_q = sprintf('xi11_vec_pilot_q_%d',k);
%     pilot_i = evalsig(x,vec_pilot_i);
%     pilot_q = evalsig(x,vec_pilot_q);
%     u_i = pilot_i(p+1:length(pilot_i));
%     u_q = pilot_q(p+1:length(pilot_q));
% 
%     vec_dqam_i = sprintf('xi11_vec_dqam_i_%d',k);
%     vec_dqam_q = sprintf('xi11_vec_dqam_q_%d',k);
%     dqam_i = evalsig(x,vec_dqam_i);
%     dqam_q = evalsig(x,vec_dqam_q);
%     v_i = dqam_i(p+1:length(dqam_i));
%     v_q = dqam_q(p+1:length(dqam_q));
% 
%     k = k+1;
%     figure(k)
%     plot(u_i, u_q,'b*', v_i,v_q,'ro')
%     title('transmitted symbols (blue *) , received symbols (red o)')
%     axis([-1 1 -1 1])    
%     grid on;
% end


%(2)
k = 0;
for (n=1:N)
    % Transmitted symbols
    vec_pilot_i = sprintf('xi11_vec_pilot_i_%d',k);
    vec_pilot_q = sprintf('xi11_vec_pilot_q_%d',k);
    pilot_i = evalsig(x,vec_pilot_i);
    pilot_q = evalsig(x,vec_pilot_q);
    u_i = pilot_i(p+1:length(pilot_i));
    u_q = pilot_q(p+1:length(pilot_q));

    vec_z_i = sprintf('xi11_vec_z_i_%d',k);
    vec_z_q = sprintf('xi11_vec_z_q_%d',k);
    z_i = evalsig(x,vec_z_i);
    z_q = evalsig(x,vec_z_q);
    v_i = z_i(p+1:length(z_i));
    v_q = z_q(p+1:length(z_q));

    k = k+1;
    figure(k)
    plot(u_i, u_q,'b*', v_i,v_q,'ro')
    title(strcat('Subchannel ',num2str(k-1),': transmitted symbols (blue *) , received symbols (red o)'))
    axis([-1.5 1.5 -1.5 1.5])    
    grid on;
end
